# Class FailOverExecutionControlProvider

java.lang.Object
jdk.jshell.execution.FailOverExecutionControlProvider

All Implemented Interfaces:
  `ExecutionControlProvider`

public class FailOverExecutionControlProvider extends Object implements ExecutionControlProvider
Tries other providers in sequence until one works.

Since:
  9

## Constructor Summary

Constructors
Constructor
Description
`FailOverExecutionControlProvider()`
Create an instance.

## Method Summary

Modifier and Type
Method
Description
`Map<String,String>`
`defaultParameters()`
Create and return the default parameter map for this `ExecutionControlProvider`.
`ExecutionControl`
`generate(ExecutionEnv env, Map<String,String> parameters)`
Create and return a locally executing `ExecutionControl` instance.
`String`
`name()`
The unique name of this `ExecutionControlProvider`.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`String`
`toString()`
Returns a string representation of the object.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Constructor Details

### FailOverExecutionControlProvider

public FailOverExecutionControlProvider()
Create an instance. The instance can be used to start and return an `ExecutionControl` instance by attempting to start a series of `ExecutionControl` specs, until one is successful.

See Also:
  - `generate(jdk.jshell.spi.ExecutionEnv, java.util.Map)`

## Method Details

### name

public String name()
The unique name of this `ExecutionControlProvider`.

Specified by:
  `name` in interface `ExecutionControlProvider`
Returns:
  "failover"

### defaultParameters

public Map<String,String> defaultParameters()
Create and return the default parameter map for this `ExecutionControlProvider`. There are ten parameters, "0" through "9", their values are `ExecutionControlProvider` specification strings, or empty string.

Specified by:
  `defaultParameters` in interface `ExecutionControlProvider`
Returns:
  a default parameter map

### generate

public ExecutionControl generate(ExecutionEnv env, Map<String,String> parameters) throws Throwable
Create and return a locally executing `ExecutionControl` instance. At least one parameter should have a spec.

Specified by:
  `generate` in interface `ExecutionControlProvider`
Parameters:
  `env` - the execution environment, provided by JShell
  `parameters` - the modified parameter map.
Returns:
  the execution engine
Throws:
  `Throwable` - if all the given providers fail, the exception that occurred on the first attempt to create the execution engine.